'-----------------------------------------------------------------------------------------
'name                     : attiny2313_alps_1.bas
'copyright                : (c) danzup
'purpose                  : Preamp controller
'micro                    : Attiny2313
'version                  : 1.0
'modified                 : by Pryanick 03.2010
'4 outputs for BASS
'4 outputs for TREBLE
'4 outputs for Amplifire input voltage selection (sencitivity)
'-----------------------------------------------------------------------------------------
$regfile = "attiny2313.dat"                                 ' specify the used micro
$crystal = 8000000                                          ' used crystal frequency
Config Portb = Output
Config Portd.3 = Output
Config Portd.4 = Output
Config Portd.5 = Output
Config Portd.6 = Output
Dim Address As Byte , Command As Byte                       'RC5 ir variable
Dim Inp_selbass As Word
Dim Inp_seltreble As Word
Dim Amp_sel As Word
Portb = &B10001000
Portd = &B0001000
Declare Sub Shiftbasslf                                     'bass left
Declare Sub Shiftbassrt                                     'bass right
Declare Sub Shifttreblelf                                   'treble left
Declare Sub Shifttreblert                                   'treble right
Declare Sub Shiftampsellf                                   'ampsel left
Declare Sub Shiftampselrt                                   'ampsel right
Config Rc5 = Pind.2                                         'pin where is conected ir senzor
Inp_selbass = 0
Inp_seltreble = 0
Amp_sel = 0
Enable Interrupts
Do
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = 0 Then
     Command = Command
  End If
 Select Case Command
 '---- this codes are for my remote , change code to your suit ! ----------------
   Case 41 : Call Shiftbasslf                               'remote command code for BASS up
   Case 42 : Call Shiftbassrt                               'remote command code for BASS down
   Case 43 : Call Shifttreblelf                             'remote command code for TREBLE up
   Case 44 : Call Shifttreblert                             'remote command code for TREBLE down
   Case 14 : Call Shiftampsellf                             'remote command code for AMPsel up
   Case 34 : Call Shiftampselrt                             'remote command code for AMPsel down
 End Select
Loop
End
'---------shift bass Left----------
Sub Shiftbasslf:
If Inp_selbass < 3 Then
Inp_selbass = Inp_selbass + 1
Select Case Inp_selbass
Case 0 : Set Portb.7
          Reset Portb.6
          Reset Portb.5
          Reset Portb.4
Case 1 : Reset Portb.7
          Set Portb.6
          Reset Portb.5
          Reset Portb.4
Case 2 : Reset Portb.7
          Reset Portb.6
         Set Portb.5
          Reset Portb.4
Case 3 : Reset Portb.7
          Reset Portb.6
          Reset Portb.5
          Set Portb.4
End Select
End If
Waitms 300
End Sub
'--------shift bass right----------
Sub Shiftbassrt:
If Inp_selbass > 0 Then
Inp_selbass = Inp_selbass - 1
Select Case Inp_selbass
Case 0 : Set Portb.7
          Reset Portb.6
          Reset Portb.5
          Reset Portb.4
Case 1 : Reset Portb.7
          Set Portb.6
          Reset Portb.5
          Reset Portb.4
Case 2 : Reset Portb.7
          Reset Portb.6
         Set Portb.5
          Reset Portb.4
Case 3 : Reset Portb.7
          Reset Portb.6
          Reset Portb.5
          Set Portb.4
End Select
End If
Waitms 300
End Sub

'---------shift treble Left----------
Sub Shifttreblelf:
If Inp_seltreble < 3 Then
Inp_seltreble = Inp_seltreble + 1
Select Case Inp_seltreble
Case 0 : Set Portb.3
          Reset Portb.2
          Reset Portb.1
          Reset Portb.0
Case 1 : Reset Portb.3
          Set Portb.2
          Reset Portb.1
          Reset Portb.0
Case 2 : Reset Portb.3
          Reset Portb.2
         Set Portb.1
          Reset Portb.0
Case 3 : Reset Portb.3
          Reset Portb.2
          Reset Portb.1
          Set Portb.0
End Select
End If
Waitms 300
End Sub
'--------shift treble right----------
Sub Shifttreblert:
If Inp_seltreble > 0 Then
Inp_seltreble = Inp_seltreble - 1
Select Case Inp_seltreble
Case 0 : Set Portb.3
          Reset Portb.2
          Reset Portb.1
          Reset Portb.0
Case 1 : Reset Portb.3
          Set Portb.2
          Reset Portb.1
          Reset Portb.0
Case 2 : Reset Portb.3
          Reset Portb.2
         Set Portb.1
          Reset Portb.0
Case 3 : Reset Portb.3
          Reset Portb.2
          Reset Portb.1
          Set Portb.0
End Select
End If
Waitms 300
End Sub
'---------shift amp Left----------
Sub Shiftampsellf:
If Amp_sel < 3 Then
Amp_sel = Amp_sel + 1
Select Case Amp_sel
Case 0 : Set Portd.6
          Set Portd.3
          Waitms 50
          Reset Portd.6
          Reset Portd.4
          Reset Portd.5
Case 1 : Set Portd.3
          Set Portd.4
          Waitms 50
          Reset Portd.3
          Reset Portd.5
          Reset Portd.6
Case 2 : Reset Portd.3
          Set Portd.4
          Set Portd.5
          Waitms 50
          Reset Portd.4
          Reset Portd.6
Case 3 : Reset Portd.3
          Reset Portd.4
          Set Portd.5
          Set Portd.6
          Waitms 50
          Reset Portd.5
End Select
End If
Waitms 300
End Sub
'--------shift amp right----------
Sub Shiftampselrt:
If Amp_sel > 0 Then
Amp_sel = Amp_sel - 1
Select Case Amp_sel
Case 0 : Set Portd.3
          Set Portd.4
          Waitms 50
          Reset Portd.6
          Reset Portd.4
          Reset Portd.5
Case 1 : Set Portd.4
          Set Portd.5
          Waitms 50
          Reset Portd.3
          Reset Portd.5
          Reset Portd.6
Case 2 : Reset Portd.3
          Set Portd.5
         Set Portd.6
         Waitms 50
          Reset Portd.4
          Reset Portd.6
Case 3 : Set Portd.3
          Set Portd.6
          Waitms 50
          Reset Portd.5
          Reset Portd.6
          Reset Portd.4
End Select
End If
Waitms 300
End Sub